# $Id: curses.rb,v 1.58 2002/02/03 14:39:52 toki Exp $
# --
# :
#   Curses 󥿡ե
#
# 饹⥸塼:
#   module RMP3::Curses
#   module RMP3::Curses::Color
#   module RMP3::Curses::Attr
#   module RMP3::Curses::Config
#   module RMP3::Curses::Attribute
#   class RMP3::Curses::MP3InfoOut
#   class RMP3::Curses::MPG123InfoOut
#   class RMP3::Curses::RatioOut
#   class RMP3::Curses::RatioOut::Spinor
#   class RMP3::Curses::Separator
#   class RMP3::Curses::Separator::Pair
#   class RMP3::Curses::MP3InfoReader
#   class RMP3::Curses::Display
#   class RMP3::Curses::Loader
#
# ƥ饹⥸塼δط:
#   [RMP3::Curses]
#     (none)
#   [RMP3::Curses::Color]
#     <none>
#   [RMP3::Curses::Attr]
#     <none>
#   [RMP3::Curses::Config]
#     <include>
#       RMP3::Config (rmp3.rb)
#   [RMP3::Curses::Attribute]
#     <include>
#       Curses
#       RMP3::Curses::Color
#       RMP3::Curses::Attr
#       RMP3::Curses::Config
#   [RMP3::Curses::MP3InfoOut]
#     <include>
#       Curses
#       RMP3::Kconv (rmp3.rb)
#       RMP3::Curses::Config
#       RMP3::Curses::Attribute
#   [RMP3::Curses::MPG123InfoOut]
#     <include>
#       RMP3::Kconv (rmp3.rb)
#       RMP3::Curses::Config
#       RMP3::Curses::Attribute
#   [RMP3::Curses::RatioOut]
#     <include>
#       RMP3::Curses::Config
#       RMP3::Curses::Attribute
#   [RMP3::Curses::RatioOut::Spinor]
#     (none)
#   [RMP3::Curses::Separator]
#     <include>
#       RMP3::Curses::Config
#       RMP3::Curses::Attribute
#   [RMP3::Curses::Separator::Pair]
#     (none)
#   [RMP3::Curses::MP3InfoReader]
#     <include>
#       Callback
#   [RMP3::Curses::Display]
#     <include>
#       Curses
#       Keymap (callback.rb)
#       RMP3::Curses::Config
#       RMP3::Curses::Attribute
#   [RMP3::Curses::Loader]
#     <superclass>
#       RMP3::TTYLoader (rmp3.rb)
#     <include>
#       RMP3::Config
#
# ƥ饹⥸塼:
#   [RMP3::Curses]
#     DISPLAY
#     LOADER
#   [RMP3::Curses::Color]
#     <color>
#       BLACK
#       BLUE
#       CYAN
#       GREEN
#       MAGENTA
#       RED
#       WHITE
#       YELLOW
#     <table>
#       COLOR_MAP
#   [RMP3::Curses::Attr]
#     <attribute>
#       ALTCHARSET
#       ATTRIBUTES
#       BLINK
#       BOLD
#       CHARTEXT
#       COLOR
#       DIM
#       INVIS
#       NORMAL
#       PROTECT
#       REVERSE
#       STANDOUT
#       UNDERLINE
#     <table>
#       ATTR_MAP
#   [RMP3::Curses::Config]
#     <group name>
#       CURSES
#       CURS_MP3_INFO
#       CURS_MPG123_INFO
#       CURS_RATIO
#       CURS_SEPARATOR
#       CURS_PLAYLIST
#       CURS_POSITION
#       CURS_HELP
#     <attribute name>
#       COLORFUL
#       COLOR_PAIR
#       PLAIN_ATTR
#       EMPH_ATTR
#       SEP_CHAR
#       KEYMAP
#       KEY_LIST_WIDTH
#   [RMP3::Curses::Attribute]
#     COLOR_PAIR_MAP
#   [RMP3::Curses::MP3InfoOut]
#     LINES
#   [RMP3::Curses::MPG123InfoOut]
#     (none)
#   [RMP3::Curses::RatioOut]
#     LINES
#   [RMP3::Curses::RatioOut::Spinor]
#     SPINOR
#   [RMP3::Curses::Separator]
#     LINES
#   [RMP3::Curses::Separator::Pair]
#     (none)
#   [RMP3::Curses::MP3InfoReader]
#     (none)
#   [RMP3::Curses::Display]
#     <window height>
#       UPPER_WIN_LINES
#       MIDDLE_WIN_LINES
#       SEP_WIN_LINES
#     <playlist reader>
#       PLAYLIST_READER
#     <keymap callback>
#       NEXT
#       PREV
#       REFRESH
#       STOP
#       PAUSE
#       PLAY_LIST
#       POSITION
#       HELP
#     <keymap>
#       KEYMAP_TABLE
#   [RMP3::Curses::Loader]
#     (none)
#
# ƥ饹⥸塼Υ᥽å:
#   [RMP3::Curses]
#     (none)
#   [RMP3::Curses::Color]
#     <module function>
#       get_color(name)
#   [RMP3::Curses::Attr]
#     <module function>
#       get_attr(name)
#   [RMP3::Curses::Config]
#     (none)
#   [RMP3::Curses::Attribute]
#     <module function>
#       init_color_pair
#       attribute(attr)
#   [RMP3::Curses::MP3InfoOut]
#     <class method>
#       new(win)
#     <public method>
#       show(mp3_info, refresh=true)
#       refresh
#       disable { ... }
#     <private method>
#       bool(flag)
#       draw(mp3_info)
#   [RMP3::Curses::MPG123InfoOut]
#     <class method>
#       new(win)
#     <public method>
#       show(mpg123_info, refresh=true)
#       refresh
#       disable { ... }
#     <private method>
#       draw_all
#       draw_line
#   [RMP3::Curses::RatioOut]
#     <class method>
#       new(win)
#     <public method>
#       show(mpg123_info, refresh=true)
#       refresh
#       disable { ... }
#     <private method>
#       round(float)
#       draw(ratio)
#   [RMP3::Curses::RatioOut::Spinor]
#     <class method>
#       new
#     <public method>
#       get
#   [RMP3::Curses::Separator]
#     <class method>
#       new(win)
#     <public method>
#       refresh
#   [RMP3::Curses::Separator::Pair]
#     <class method>
#       new(text, len)
#     <public method>
#       text
#       len
#   [RMP3::Curses::MP3InfoReader]
#     <class method>
#       new
#       new { |mp3_info| ...return MP3 information...  }
#     <public method>
#       add_read_callback(callback)
#       add_read_callback { |read_list| ...callback... }
#       remove_read_callback(callback)
#       read_list
#       mp3_info_list
#       mp3_info_list=(list)
#       read
#     <private method>
#       dispatch_read_callback
#   [RMP3::Curses::Display]
#     <class method>
#       new
#     <public method>
#       start(app)
#       refresh
#       disable_update { ... }
#       upper_window { |win| ... }
#       middle_window { |win| ... }
#       lower_window { |win| ... }
#     <private method>
#       init(app)
#       close
#       set_keymap_table
#   [RMP3::Curses::Loader]
#     <class method>
#       new(disp)
#     <public method>
#       start(app)
#

require "thread"
require "curses.so"
require "rmp3/cmenu"
require "rmp3/cinput"
require "rmp3/callback"

module Curses
  #### for ruby 1.6 or older version ####

  class Window
    unless (method_defined? :keypad) then
      def keypad(enable)
	# dummy
      end
    end
  end

  unless (Window::method_defined? :noutrefresh) then
    class Window
      alias noutrefresh refresh
    end

    undef_method :doupdate

    def doupdate
      # dummy
    end
  end

  KEY_DOWN      = nil unless (defined? KEY_DOWN)
  KEY_UP        = nil unless (defined? KEY_UP)
  KEY_NPAGE     = nil unless (defined? KEY_NPAGE)
  KEY_PPAGE     = nil unless (defined? KEY_PPAGE)
  KEY_BACKSPACE = nil unless (defined? KEY_BACKSPACE)

  #### Curses::Window 饹γĥ ####
  class Window
    def fillstr(str, width)
      offset = curx
      addstr(str)
      if (! str || str.empty? || curx > offset) then 
	rest = width - (curx - offset)
	if (rest > 0) then
	  addstr(" " * rest)
	end
      end
    end
  end
end

module RMP3
  module Curses
    module Color
      BLACK   = "black"
      BLUE    = "blue"
      CYAN    = "cyan"
      GREEN   = "green"
      MAGENTA = "magenta"
      RED     = "red"
      WHITE   = "white"
      YELLOW  = "yellow"

      if (::Curses::methods.include? "attrset") then
	COLOR_MAP = {
	  BLACK   => ::Curses::COLOR_BLACK,
	  BLUE    => ::Curses::COLOR_BLUE,
	  CYAN    => ::Curses::COLOR_CYAN,
	  GREEN   => ::Curses::COLOR_GREEN,
	  MAGENTA => ::Curses::COLOR_MAGENTA,
	  RED     => ::Curses::COLOR_RED,
	  WHITE   => ::Curses::COLOR_WHITE,
	  YELLOW  => ::Curses::COLOR_YELLOW
	}
      else
	COLOR_MAP = {}
      end

      def get_color(name)
	color = COLOR_MAP[name]
	unless (color) then
	  raise "not defined color: #{name}"
	end
	color
      end
      module_function :get_color
    end

    module Attr
      ALTCHARSET = "altcharset"
      ATTRIBUTES = "attributes"
      BLINK      = "blink"
      BOLD       = "bold"
      CHARTEXT   = "chartext"
      COLOR      = "color"
      DIM        = "dim"
      INVIS      = "invis"
      NORMAL     = "normal"
      PROTECT    = "protect"
      REVERSE    = "reverse"
      STANDOUT   = "standout"
      UNDERLINE  = "underline"

      if (::Curses::methods.include? "attrset") then
	ATTR_MAP = {
	  ALTCHARSET => ::Curses::A_ALTCHARSET,
	  ATTRIBUTES => ::Curses::A_ATTRIBUTES,
	  BLINK      => ::Curses::A_BLINK,
	  BOLD       => ::Curses::A_BOLD,
	  CHARTEXT   => ::Curses::A_BOLD,
	  COLOR      => ::Curses::A_CHARTEXT,
	  DIM        => ::Curses::A_COLOR,
	  INVIS      => ::Curses::A_DIM,
	  NORMAL     => ::Curses::A_INVIS,
	  PROTECT    => ::Curses::A_NORMAL,
	  REVERSE    => ::Curses::A_REVERSE,
	  STANDOUT   => ::Curses::A_PROTECT,
	  UNDERLINE  => ::Curses::A_UNDERLINE,
	}
      else
	ATTR_MAP = {}
      end

      def get_attr(name)
	attr = ATTR_MAP[name]
	unless (attr) then
	  raise "not defined attribute: #{name}"
	end
	attr
      end
      module_function :get_attr
    end

    module Config
      include RMP3::Config

      #### group ####

      CURSES           = "curses"
      CURS_MP3_INFO    = "curses.mp3-info"
      CURS_MPG123_INFO = "curses.mpg123-info"
      CURS_RATIO       = "curses.ratio"
      CURS_SEPARATOR   = "curses.separator"
      CURS_PLAYLIST    = "curses.playlist"
      CURS_POSITION    = "curses.position"
      CURS_HELP        = "curses.help"

      CONFIG.add_group(CURSES, RMP3)
      CONFIG.add_group(CURS_MP3_INFO, CURSES)
      CONFIG.add_group(CURS_MPG123_INFO, CURSES)
      CONFIG.add_group(CURS_RATIO, CURSES)
      CONFIG.add_group(CURS_SEPARATOR, CURSES)
      CONFIG.add_group(CURS_PLAYLIST, CURS_MPG123_INFO)
      CONFIG.add_group(CURS_POSITION, CURS_MPG123_INFO)
      CONFIG.add_group(CURS_HELP, CURS_MPG123_INFO)


      #### attribute ####

      COLORFUL       = "colorful"
      COLOR_PAIR     = "colormap"
      PLAIN_ATTR     = "plain-attribute"
      EMPH_ATTR      = "emphsis-attribute"
      SEP_CHAR       = "separator-character"
      KEYMAP         = "keymap"
      KEY_LIST_WIDTH = "key-list-width"


      #### default settings ####

      CONFIG[CURSES, COLORFUL] = false
      CONFIG[CURSES, COLOR_PAIR] = {
	# "name" => [ "foreground", "background" ]
	"normal" => [ Color::CYAN, Color::BLUE ]
      }
      CONFIG[CURSES, PLAIN_ATTR] = [ "normal" ]
      CONFIG[CURSES, EMPH_ATTR]  = [ "normal", Attr::REVERSE ]
      CONFIG[CURS_SEPARATOR, SEP_CHAR] = "-"
      CONFIG[CURS_HELP, KEY_LIST_WIDTH] = 24

      [ # [ [<option list>],
	#   <option hook>,
	#   <option argument description or nil>
	# ], ...
	[ %w[ -c --curses-color ],
	  proc{ CONFIG[CURSES, COLORFUL] = true },
	  nil
	],
	[ %w[ +c --no-curses-color ],
	  proc{ CONFIG[CURSES, COLORFUL] = false },
	  nil
	]
      ].each do |hook|
	CONFIG[RMP3, OPTION_HOOK] << hook
      end
    end

    module Attribute
      include ::Curses
      include Color
      include Attr
      include Config

      COLOR_PAIR_MAP = {}

      def init_color_pair
	n = 0
	for name, pair in CONFIG[CURSES, COLOR_PAIR]
	  n += 1
	  ::Curses::init_pair(n, Color::get_color(pair[0]), Color::get_color(pair[1]))
	  COLOR_PAIR_MAP[name] = ::Curses::color_pair(n)
	end
      end
      module_function :init_color_pair

      def attribute(attr)
	attr_bits = 0
	set_attr_bits = proc{ |name|
	  if (color = COLOR_PAIR_MAP[name]) then
	    attr_bits |= color
	  else
	    attr_bits |= Attr::get_attr(name)
	  end
	}

	if (attr.kind_of? String) then
	  set_attr_bits.call(attr)
	else
	  for name in attr
	    set_attr_bits.call(name)
	  end
	end

	attr_bits
      end
      module_function :attribute
    end

    class MP3InfoOut
      include Kconv
      include Config
      include Attribute

      LINES = 6

      def initialize(win)
	@m = Mutex::new
	@win = win
	@enable = true
	@last_mp3_info = nil

	if (CONFIG[CURSES, COLORFUL]) then
	  @plain_attr = attribute(CONFIG[CURS_MP3_INFO, PLAIN_ATTR])
	  @emph_attr = attribute(CONFIG[CURS_MP3_INFO, EMPH_ATTR])
	else
	  @plain_attr = nil
	  @emph_attr = nil
	end
      end

      def draw(mp3_info)
	y = 0
	[ # [ [ <attr.>, "<text>", <width> ],
	  #   ...
	  # ], ...
	  [ [ @emph_attr, "Title", 7 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr, mp3_info && mp3_info.title, 32 ],
	    [ @emph_attr, "Year", 5 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr, mp3_info && mp3_info.year, 0 ]
	  ],
	  [ [ @emph_attr, "Album", 7 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1],
	    [ @plain_attr, mp3_info && mp3_info.album, 32 ],
	    [ @emph_attr, "Genre", 5 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr, mp3_info && mp3_info.genre, 0 ]
	  ],
	  [ [ @emph_attr, "Artist", 7 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " " , 1 ],
	    [ @plain_attr, mp3_info && mp3_info.artist, 32 ],
	    [ @emph_attr, "Time", 5 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr,
	      mp3_info && format("%02d:%02d [%d]",
				 mp3_info.minutes,
				 mp3_info.remaining_seconds,
				 mp3_info.seconds),
	      0
	    ]
	  ],
	  [ [ @emph_attr, "Comment", 7 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr, mp3_info && mp3_info.comment, 32 ],
	    [ @emph_attr, "CRC", 5 ],
	    [ @emph_attr, ":", 1 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr,
	      mp3_info && (mp3_info.error_protection ? "Yes" : "No"),
	      0
	    ]
	  ],
	  [ [ @emph_attr, "Copyright:", 0 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr,
	      mp3_info && (mp3_info.copyright ? "Yes" : "No"), 7 ],
	    [ @emph_attr, "Original:", 0 ],
	    [ @plain_attr, " ", 1],
	    [ @plain_attr,
	      mp3_info && (mp3_info.original ? "Yes" : "No"), 7 ],
	    [ @emph_attr, "File:", 0 ],
	    [ @plain_attr, " ", 1 ],
	    [ @plain_attr, mp3_info && File::basename(mp3_info.filename), 0 ]
	  ],
	  [ [ @plain_attr,
	      mp3_info && [
		mp3_info.version,
		"Layer #{mp3_info.layer}",
		"#{mp3_info.sampling / 1000.0} kHz",
		"#{mp3_info.bitrate} kBits/sec",
		"#{mp3_info.mode}",
		"#{mp3_info.file_size / 1024} KBytes"
	      ].join(", "),
	      0
	    ]
	  ]
	].each do |line|
	  written = false
	  @win.setpos(y, 0)
	  for attr, text, width in line
	    @win.attrset(attr) if attr
	    @win.fillstr(text && kconv(text), width)
	    if (text || width > 0) then
	      written = true
	    end
	  end
	  @win.attrset(@plain_attr) if @plain_attr
	  if (! written || @win.curx > 0) then
	    @win.addstr(" " * (@win.maxx - @win.curx))
	  end
	  y += 1
	end
	@win.attrset(A_NORMAL) if (@plain_attr || @emph_attr)
      end
      private :draw

      def show(mp3_info, refresh=true)
	@m.synchronize do
	  @last_mp3_info = mp3_info
	  if (@enable) then
	    draw(nil)
	    @win.refresh
	    draw(mp3_info)
	    if (refresh) then
	      @win.refresh
	    else
	      @win.noutrefresh
	    end
	  end
	end
      end

      def refresh(clear=true)
	@m.synchronize do
	  if (@enable) then
	    if (clear) then
	      @win.clear
	    else
	      draw(nil)
	      @win.refresh
	    end
	    draw(@last_mp3_info)
	    @win.refresh
	  end
	end
      end

      # disable { ... }
      def disable
	@enable = false
	begin
	  yield
	ensure
	  @enable = true
	  refresh(false)
	end
      end
    end

    class MPG123InfoOut
      include Kconv
      include Config
      include Attribute

      def initialize(win)
	@m = Mutex::new
	@win = win
	@lines = []
	@last_ret = false
	@enable = true

	if (CONFIG[CURSES, COLORFUL]) then
	  @plain_attr = attribute(CONFIG[CURS_MPG123_INFO, PLAIN_ATTR])
	  @emph_attr = attribute(CONFIG[CURS_MPG123_INFO, EMPH_ATTR])
	else
	  @plain_attr = nil
	  @emph_attr = nil
	end
      end

      def draw_all
	y = 0
	@win.attrset(@plain_attr) if @plain_attr
	for line in @lines
	  @win.setpos(y, 0)
	  @win.fillstr(line, @win.maxx)
	  y += 1
	end
	for yy in y..(@win.maxy - 1)
	  @win.setpos(yy, 0)
	  @win.addstr(" " * @win.maxx)
	end
	@win.attrset(A_NORMAL) if @plain_attr
      end
      private :draw_all

      def draw_line
	line = @lines[-1]
	@win.setpos(@lines.length - 1, 0)
	@win.attrset(@plain_attr) if @plain_attr
	@win.fillstr(line, @win.maxx)
	@win.attrset(A_NORMAL) if @plain_attr
      end
      private :draw_line

      def show(mpg123_info, refresh=true)
	@m.synchronize do
	  ret = false
	  scroll = false
	  line = kconv(mpg123_info.line)
	  if (line[-1] == ?\r) then
	    ret = true
	  end
	  line.chop!
	  if (@last_ret && ! @lines.empty?) then
	    @lines[-1] = line
	  else
	    @lines.push(line)
	    if (@lines.length > @win.maxy) then
	      @lines.shift
	      scroll = true
	    end
	  end
	  @last_ret = ret

	  if (@enable) then
	    if (scroll) then
	      draw_all
	    else
	      draw_line
	    end
	    if (refresh) then
	      @win.refresh
	    else
	      @win.noutrefresh
	    end
	  end
	end
      end

      def refresh(clear=true)
	@m.synchronize do
	  if (@enable) then
	    @win.clear if clear
	    draw_all
	    @win.refresh
	  end
	end
      end

      # disable { ... }
      def disable
	@enable = false
	begin
	  yield
	ensure
	  @enable = true
	  refresh(false)
	end
      end
    end

    class RatioOut
      class Spinor
	SPINOR = "- \\ | / - \\ | /".split

	def initialize
	  @count = -1
	end

	def get
	  @count = (@count + 1) % SPINOR.length
	  SPINOR[@count]
	end
      end

      include Config
      include Attribute

      LINES = 1

      def initialize(win)
	@m = Mutex::new
	@win = win
	@ratio = 0.0
	@spinor = Spinor::new
	@enable = true

	if (CONFIG[CURSES, COLORFUL]) then
	  @plain_attr = attribute(CONFIG[CURS_RATIO, PLAIN_ATTR])
	  @emph_attr = attribute(CONFIG[CURS_RATIO, EMPH_ATTR])
	else
	  @plain_attr = nil
	  @emph_attr = nil
	end
      end

      def draw(ratio)
	@win.setpos(0, 0)
	@win.attrset(@plain_attr) if @plain_attr
	@win.addstr(format("%3d%%", (ratio * 100).round))
	@win.addstr(@spinor.get)
	width = @win.maxx - 5
	left = (width * ratio).round
	right = width - left
	if (@emph_attr) then
	  @win.attrset(@emph_attr)
	else
	  @win.standout
	end
	@win.addstr(" " * left)
	if (@plain_attr) then
	  @win.attrset(@plain_attr)
	else
	  @win.standend
	end
	@win.addstr(" " * right)
	@win.attrset(A_NORMAL) if (@plain_attr || @emph_attr)
      end
      private :draw

      def show(mpg123_info, refresh=true)
	@m.synchronize do
	  if (mpg123_info.valid_frame?) then
	    total_frames = mpg123_info.frames + mpg123_info.remaining_frames
	    if (total_frames > 0) then
	      @ratio = mpg123_info.frames.to_f / total_frames
	    else
	      @ratio = 0.0
	    end
	  end
	  if (@enable) then
	    draw(@ratio)
	    if (refresh) then
	      @win.refresh
	    else
	      @win.noutrefresh
	    end
	  end
	end
      end

      def refresh(clear=true)
	@m.synchronize do
	  if (@enable) then
	    @win.clear if clear
	    draw(@ratio)
	    @win.refresh
	  end
	end
      end

      # disable { ... }
      def disable
	@enable = false
	begin
	  yield
	ensure
	  @enable = true
	  refresh(false)
	end
      end
    end

    class Separator
      class Pair
	def initialize(text, len)
	  @text = text
	  @len = len
	end

	attr :text
	attr :len
      end

      include Config
      include Attribute

      LINES = 1

      def initialize(win)
	@win = win

	@sep = []
	text = CONFIG[CURS_SEPARATOR, SEP_CHAR]
	until (text.empty?)
	  @win.setpos(0, 0)
	  @win.addstr(text)
	  @sep << Pair::new(text, @win.curx)
	  text = text.sub(/.$/, '')
	end

	if (CONFIG[CURSES, COLORFUL]) then
	  @plain_attr = attribute(CONFIG[CURS_SEPARATOR, PLAIN_ATTR])
	  @emph_attr = attribute(CONFIG[CURS_SEPARATOR, EMPH_ATTR])
	else
	  @plain_attr = nil
	  @emph_attr = nil
	end
      end

      def refresh(clear=true)
	@win.clear if clear
	@win.setpos(0, 0)
	@win.attrset(@plain_attr) if @plain_attr
	if (@sep.empty?) then
	  @win.addstr(" " * @win.maxx)
	else
	  num = @win.maxx / @sep[0].len
	  rest = @win.maxx - num * @sep[0].len
	  @win.addstr(@sep[0].text * num)
	  if (last = @sep.find{ |sep| sep.len <= rest }) then
	    @win.fillstr(last.text, rest)
	  else
	    @win.addstr(" " * rest)
	  end
	end
	@win.attrset(A_NORMAL) if @plain_attr
	@win.refresh
      end
    end

    class MP3InfoReader
      include Callback

      # 1. new
      # 2. new { |mp3_info| ... }
      def initialize(&block)
	@m = Mutex::new
	@mp3_info_list = []
	if (block) then
	  @mp3_info_conv = block
	else
	  @mp3_info_conv = proc{ |mp3_info| mp3_info.to_s }
	end
	@read_list = []
	@read_thread = nil
	@read_callback = []
      end

      #
      # 1. add_read_callback(callback)
      # 2. add_read_callback { |read_list| ...callback... }
      # -
      # callback ϼΥ᥽åɤʤФʤʤ
      #   callback.call(read_list)
      #
      def add_read_callback(callback=nil, &block)
	add_callback(@read_callback, callback, &block)
      end

      def remove_read_callback(callback)
	remove_callback(@read_callback, callback)
      end

      def dispatch_read_callback(read_list)
	dispatch_callback(@read_callback, read_list)
      end
      private :dispatch_read_callback

      attr :read_list
      attr :mp3_info_list

      def mp3_info_list=(list)
	@m.synchronize do
	  if (@read_thread) then
	    @read_thread.join
	    @read_thread = nil
	  end
	  @mp3_info_list = list
	  @read_list.clear
	  @read = false
	end
      end

      def read
	@m.synchronize do
	  unless (@read_thread) then
	    @read_thread = Thread::new{
	      for mp3_info in @mp3_info_list
		@read_list << @mp3_info_conv.call(mp3_info)
		dispatch_read_callback(@read_list)
	      end
	    }
	  end
	end
      end
    end

    class Display
      include ::Curses
      include Keymap
      include Config
      include Attribute

      UPPER_WIN_LINES  = MP3InfoOut::LINES
      MIDDLE_WIN_LINES = RatioOut::LINES
      SEP_WIN_LINES    = Separator::LINES

      PLAYLIST_READER = MP3InfoReader::new{ |mp3_info|
	Kconv::kconv("#{mp3_info.index + 1}. #{mp3_info}")
      }

      def init(app)
	@keymap = {}
	set_keymap_table

	init_screen
	cbreak
	noecho

	if (CONFIG[CURSES, COLORFUL]) then
	  unless (has_colors?) then
	    raise "cannot use colors"
	  end
	  start_color
	  init_color_pair
	end

	x = 0
	y = 0
	@upper_win = Window::new(UPPER_WIN_LINES, cols, y, x)
	y += UPPER_WIN_LINES
	@middle_win = Window::new(MIDDLE_WIN_LINES, cols, y, x)
	y += MIDDLE_WIN_LINES
	@sep_win = Window::new(SEP_WIN_LINES, cols, y, x)
	h = lines - (UPPER_WIN_LINES + MIDDLE_WIN_LINES + SEP_WIN_LINES)
	y += SEP_WIN_LINES
	@lower_win = Window::new(h, cols, y, x)

	@upper_win.keypad(true)
	@middle_win.keypad(true)
	@lower_win.keypad(true)

	@update = true
	@mp3_info_out = MP3InfoOut::new(@upper_win)
	@ratio_out = RatioOut::new(@middle_win)
	@separator = Separator::new(@sep_win)
	@mpg123_info_out = MPG123InfoOut::new(@lower_win)
	refresh(false)

	app.player.add_mp3_info_callback do |player, mp3_info|
	  @mp3_info_out.show(mp3_info)
	end
	app.player.add_mpg123_info_callback do |player, mp3_info, mpg123_info|
	  @ratio_out.show(mpg123_info, false)
	end
	app.player.add_mpg123_info_callback do |player, mp3_info, mpg123_info|
	  @mpg123_info_out.show(mpg123_info, false)
	end
	app.player.add_mpg123_info_callback do |player, mp3_info, mpg123_info|
	  doupdate if @update
	end
	app.player.add_preplay_callback do |player|
	  PLAYLIST_READER.mp3_info_list = player.list
	end
	port = [ STDIN ]
	app.player.add_playing_callback do |player|
	  if (IO::select(port, nil, nil, 0)) then
	    hook_key(@lower_win.getch, self, player)
	  end
	end
      end
      private :init

      def close
	@lower_win.setpos(@lower_win.maxy - 1, 0)
	@lower_win.addstr(" " * @lower_win.maxx)
	@lower_win.refresh

	@upper_win.close
	@middle_win.close
	@sep_win.close
	@lower_win.close

	close_screen
      end
      private :close

      def start(app)
	init(app)
	begin
	  app.start
	ensure
	  close
	end
      end

      def refresh(clear=true)
	@mp3_info_out.refresh(clear)
	@mpg123_info_out.refresh(clear)
	@ratio_out.refresh(clear)
	@separator.refresh(clear)
      end

      # disable_update { ... }
      def disable_update
	@update = false
	begin
	  yield
	ensure
	  @update = true
	end
      end

      # upper_window { |win| ... }
      def upper_window
	@mp3_info_out.disable do
	  yield(@upper_win)
	end
      end

      # middle_window { |win| ... }
      def middle_window
	@ratio_out.disable.disable do
	  yield(@middle_window)
	end
      end

      # lower_window { |win| ... }
      def lower_window
	@mpg123_info_out.disable do
	  yield(@lower_win)
	end
      end

      # [NOTE]
      # Keymap module method (callback.rb)
      # -
      # 1. set_keymap(key, callback)
      # 2. set_keymap(key) { |disp, player| ... }
      # -
      # callback ϼΥ᥽åɤʤФʤʤ
      #   callback.call(disp, player)
      #


      #### Callback ####

      NEXT    = proc{ |disp, player| player.next }
      PREV    = proc{ |disp, player| player.prev }
      REFRESH = proc{ |disp, player| disp.refresh }
      STOP    = proc{ |disp, player| player.stop }

      PAUSE = proc{ |disp, player|
	player.pause do
	  disp.lower_window do |win|
	    disp.disable_update do
	      if (CONFIG[CURSES, COLORFUL]) then
		plain_attr = Attribute::attribute(CONFIG[CURS_MPG123_INFO, PLAIN_ATTR])
		emph_attr = Attribute::attribute(CONFIG[CURS_MPG123_INFO, EMPH_ATTR])
	      end

	      y = win.cury
	      win.setpos(y, 0)
	      win.attrset(plain_attr) if plain_attr
	      win.addstr(" " * win.maxx)
	      win.setpos(y, 0)
	      win.attrset(emph_attr) if emph_attr
	      win.addstr("<PAUSE: Hit any key>")
	      win.attrset(A_NORMAL) if (plain_attr || emph_attr)

	      win.refresh
	      win.getch
	    end
	  end
	end
      }

      PLAYLIST = proc{ |disp, player|
	disp.upper_window do |upper_win|
	  disp.lower_window do |lower_win|
	    player.set_index do |play_list, play_index|
	      mp3_info_out = MP3InfoOut::new(upper_win)
	      mp3_info_out.show(player.mp3_info)

	      menu = Menu::new(lower_win, true)
	      if (CONFIG[CURSES, COLORFUL]) then
		menu.plain_attr = Attribute::attribute(CONFIG[CURS_PLAYLIST, PLAIN_ATTR])
		menu.cursor_attr = Attribute::attribute(CONFIG[CURS_PLAYLIST, EMPH_ATTR])
	      end

	      keymap = CONFIG[CURS_PLAYLIST, KEYMAP].collect{ |keys, callback|
		# [ [<key list>], <callback> ]
		[ keys[0], callback[0] ]
	      }
	      make_mp3_info_refresh_callback = proc{ |callback|
		# [ [<key list>], <callback> ]
		[ keymap.rassoc(callback)[0] || [],
		  proc{ |m|
		    callback.call(m)
		    mp3_info_out.show(play_list[m.index])
		  }
		]
	      }

	      (keymap + [
		 # [ [<key list>], <callback> ], ...
		 [ keymap.rassoc(Menu::REDRAW)[0],
		   proc{ |m|
		     Menu::REDRAW.call(m)
		     mp3_info_out.refresh
		     disp.refresh
		   }
		 ],
		 make_mp3_info_refresh_callback.call(Menu::PREV_ITEM),
		 make_mp3_info_refresh_callback.call(Menu::NEXT_ITEM),
		 make_mp3_info_refresh_callback.call(Menu::PREV_PAGE),
		 make_mp3_info_refresh_callback.call(Menu::NEXT_PAGE)
	       ]).each do |keys, callback|
		for key in keys
		  menu.set_keymap(key, callback)
		end
	      end

	      PLAYLIST_READER.read
	      menu.list = PLAYLIST_READER.read_list

	      m = Mutex::new
	      update = false
	      refresh_menu = proc{ |read_list|
		m.synchronize do
		  if (update) then
		    if (menu.list.length - 1 < play_index) then
		      if (menu.list.empty?) then
			menu.index = 0
		      else
			menu.index = menu.list.length - 1
		      end
		    end
		    menu.refresh
		  end
		end
	      }

	      PLAYLIST_READER.add_read_callback(refresh_menu)
	      begin
		sleep(0.1) while (menu.list.length - 1 < play_index)
		menu.index = play_index
		menu.refresh
		update = true
		menu.get
	      ensure
		m.synchronize do
		  update = false
		  PLAYLIST_READER.remove_read_callback(refresh_menu)
		end
	      end
	    end
	  end
	end
      }

      POSITION = proc{ |disp, player|
	disp.lower_window do |win|
	  player.set_skip_frames do |mp3_info, mpg123_info|
	    total_frames =
	      mpg123_info.frames + mpg123_info.remaining_frames
	    total_seconds =
	      mpg123_info.seconds + mpg123_info.remaining_seconds

	    if (CONFIG[CURSES, COLORFUL]) then
	      plain_attr = Attribute::attribute(CONFIG[CURS_POSITION, PLAIN_ATTR])
	      emph_attr = Attribute::attribute(CONFIG[CURS_POSITION, EMPH_ATTR])
	    end

	    win.attrset(plain_attr) if plain_attr
	    for y in 0..(win.maxy - 1)
	      win.setpos(y, 0)
	      win.addstr(" " * win.maxx)
	    end

	    y = 0
	    [ "<<< Current position >>>",
	      format("Time : %d:%02d [%.2f] / %d:%02d [%.2f]",
		     mpg123_info.seconds / 60, mpg123_info.seconds % 60,
		     mpg123_info.seconds,
		     total_seconds / 60, total_seconds % 60,
		     total_seconds),
	      format("Ratio: %.2f %%",
		     100 * mpg123_info.seconds / total_seconds),
	      "",
	      "<<< Key bindings >>>",
	      "RET.    Determine",
	      "^G      Cancel",
	      "^U      Clear input",
	      "^H      Erase last character",
	      "",
	      "<<< Input Format >>>",
	      "[minutes]:[seconds] or [seconds] or [percentage]%",
	      ""
	    ].each do |line|
	      win.setpos(y, 0)
	      win.addstr(line)
	      y += 1
	    end
	    win.setpos(win.cury + 1, 0)
	    win.addstr "Input position: "

	    chars = [ ?., ?:, ?%, ?0, ?1, ?2, ?3, ?4, ?5, ?6, ?7, ?8, ?9 ]
	    cin = Input::new(win, chars)
	    cin.input = [
	      (mpg123_info.seconds / 60).to_i,
	      mpg123_info.seconds % 60
	    ].join(":")
	    cin.plain_attr = plain_attr
	    cin.text_attr = emph_attr

	    skip = nil
	    disp.disable_update do
	      update = proc{ |player, mp3_info, mpg123_info|
		win.noutrefresh
		::Curses::doupdate
	      }
	      player.add_mpg123_info_callback(update)
	      begin
		skip = cin.gets
	      ensure
		player.remove_mpg123_info_callback(update)
	      end
	    end

	    if (skip) then
	      if (skip =~ /%$/) then
		# percentage format
		skip_seconds = skip.chop.to_f * total_seconds / 100
	      else
		# time format
		skip_seconds = 0
		for t in skip.split(/:/, -1)
		  skip_seconds = skip_seconds * 60 + t.to_f
		end
	      end
	      (total_frames * (skip_seconds / total_seconds)).round
	    end
	  end
	end
      }

      HELP = proc{ |disp, player|
	disp.lower_window do |win|
	  if (CONFIG[CURSES, COLORFUL]) then
	    plain_attr = Attribute::attribute(CONFIG[CURS_HELP, PLAIN_ATTR])
	    emph_attr = Attribute::attribute(CONFIG[CURS_HELP, EMPH_ATTR])
	  end
	  key_list_width = CONFIG[CURS_HELP, KEY_LIST_WIDTH]
	  help_list = (CONFIG[CURS_MPG123_INFO, KEYMAP] +
		       CONFIG[CURS_PLAYLIST, KEYMAP]).collect{ |keys, callback|
	    # [ [<key desc. list>], <callback desc.> ]
	    [ keys[1], callback[1] ]
	  }
	  help_list2 = []
	  0.step(help_list.length - 1, win.maxy - 1) do |i|
	    help_list2 << help_list[i, win.maxy - 1]
	  end

	  for help_list in help_list2
	    y = 0
	    key_sep = ", "
	    for key_desc_list, callback_desc in help_list
	      win.setpos(y, 0)
	      for key_desc in key_desc_list[0..-2]
		win.attrset(emph_attr) if emph_attr
		win.addstr(key_desc)
		win.attrset(plain_attr) if plain_attr
		win.addstr(key_sep)
	      end
	      win.attrset(emph_attr) if emph_attr
	      win.addstr(key_desc_list[-1])
	      win.attrset(plain_attr) if plain_attr
	      win.addstr(" ")
	      rest = key_list_width - win.curx
	      if (rest > 0) then
		win.addstr(" " * rest)
	      end
	      if (defined? callback_desc.call) then
		win.fillstr(callback_desc.call, win.maxx - win.curx)
	      else
		win.fillstr(callback_desc, win.maxx - win.curx)
	      end
	      y += 1
	    end

	    for yy in y..(win.maxy - 1)
	      win.setpos(yy, 0)
	      win.addstr(" " * win.maxx)
	    end
	    win.setpos(y, 0)
	    win.addstr("<hit any key>")
	    win.attrset(A_NORMAL) if (plain_attr || emph_attr)
	    win.refresh

	    disp.disable_update do
	      update = proc{ |player, mp3_info, mpg123_info|
		win.noutrefresh
		::Curses::doupdate
	      }
	      player.add_mpg123_info_callback(update)
	      begin
		win.getch
	      ensure
		player.remove_mpg123_info_callback(update)
	      end
	    end
	  end
	end
      }

      CONFIG[CURS_MPG123_INFO, KEYMAP] = [
	# [ [ [<key list>], [<key desc. list>] ],
	#   [ <callback>, <callback desc.> ]
	# ], ...
	[ [ [ ?N, ?n ], [ "N" ] ],
	  [ NEXT, "Next file." ]
	],
	[ [ [ ?P, ?p ], [ "P" ] ],
	  [ PREV, "Previous file." ]
	],
	[ [ [ ?\C-l ], [ "^L" ] ],
	  [ REFRESH, "Refresh screen." ]
	],
	[ [ [ ?\e, ?Q, ?q, ?X, ?x, ?/ ],
	    [ "[ESCAPE]", "Q", "X", "/" ]
	  ],
	  [ STOP, "Exit." ]
	],
	[ [ [ ?\ , ?S, ?s, ],
	    [ "[SPACE]", "S" ]
	  ],
	  [ PAUSE, "Pause." ]
	],
	[ [ [ ?L, ?l ], [ "L" ] ],
	  [ PLAYLIST, "Playlist menu." ]
	],
	[ [ [ ?@ ], [ "@" ] ],
	  [ POSITION, "Position." ]
	],
	[ [ [ ?H, ?h, ?? ], [ "H", "?" ] ],
	  [ HELP, "Help." ]
	]
      ]

      CONFIG[CURS_PLAYLIST, KEYMAP] = [
	# [ [ [<key list>], [<key desc. list>] ],
	#   [ <callback>, <callback desc.> ]
	# ], ...
	[ [ [ KEY_DOWN, ?N, ?n, ?J, ?j ],
	    [ "[DOWN]", "N", "J" ]
	  ],
	  [ Menu::NEXT_ITEM, "Next item of playlist menu." ]
	],
	[ [ [ KEY_UP, ?P, ?p, ?K, ?k ],
	    [ "[UP]", "P", "K" ]
	  ],
	  [ Menu::PREV_ITEM, "Previous item of playlist menu." ]
	],
	[ [ [ KEY_NPAGE, ?\ , ?\C-f ],
	    [ "[NEXT PAGE]", "[SPACE]", "^F" ]
	  ],
	  [ Menu::NEXT_PAGE, "Next page of playlist menu." ]
	],
	[ [ [ KEY_PPAGE, KEY_BACKSPACE, ?\C-b ],
	    [ "[PREV. PAGE]", "[BACKSPACE]", "^B" ]
	  ],
	  [ Menu::PREV_PAGE, "Previous page of playlist menu." ]
	],
	[ [ [ ?\n ], [ "[ENTER]", "^M" ] ],
	  [ Menu::ENTER, "Select playlist menu item." ]
	],
	[ [ [ ?\e, ?Q, ?q, ?X, ?x, ?L, ?l, ?/ ],
	    [ "[ESCAPE]", "Q", "X", "L", "/" ]
	  ],
	  [ Menu::CANCEL, "Cancel playlist menu." ]
	],
	[ [ [ ?\C-l ], [ "^L" ] ],
	  [ Menu::REDRAW, "Refresh playlist menu." ]
	]
      ]

      def set_keymap_table
	keymap = CONFIG[CURS_MPG123_INFO, KEYMAP].collect{ |keys, callback|
	  [ keys[0], callback[0] ]
	}
	for keys, callback in keymap
	  for key in keys
	    set_keymap(key, callback)
	  end
	end
      end
      private :set_keymap_table
    end

    class Loader < TTYLoader
      include Config

      def initialize(disp)
	super(CURSES)
	@disp = disp
      end

      def start(app)
	@disp.start(app)
      end
    end

    DISPLAY = Display::new
    LOADER = Loader::new(DISPLAY)
  end

  # registration
  add_loader(Curses::LOADER)
end
