# $Id: dumb.rb,v 1.7 1999/11/24 08:43:25 toki Exp $
# --
# :
#   üѥ󥿡ե
#
# 饹⥸塼:
#   module RMP3::Dumb
#   module RMP3::Dumb::Config
#   class RMP3::Dumb::Display
#   class RMP3::Dumb::Loader
#
# ƥ饹⥸塼δط:
#   [RMP3::Dumb]
#     (none)
#   [RMP3::Dumb::Config]
#     <include>
#       RMP3::Config (rmp3.rb)
#   [RMP3::Dumb::Display]
#     <include>
#       RMP3::Kconv (rmp3.rb)
#   [RMP3::Dumb::Loader]
#     <superclass>
#       RMP3::SimpleLoader
#     <include>
#       RMP3::Dumb::Config
#
# ƥ饹⥸塼:
#   [RMP3::Dumb]
#     DISPLAY
#     LOADER
#     NAME
#   [RMP3::Dumb::Config]
#     DUMB
#   [RMP3::Dumb::Display]
#     (none)
#   [RMP3::Dumb::Loader]
#     (none)
#
# ƥ饹⥸塼Υ᥽å:
#   [RMP3::Dumb]
#     (none)
#   [RMP3::Dumb::Config]
#     (none)
#   [RMP3::Dumb::Display]
#     <public method>
#       start(app)
#   [RMP3::Dumb::Loader]
#     <class method>
#       new(disp)
#     <public method>
#       start(app)
#

module RMP3
  module Dumb
    module Config
      include RMP3::Config

      #### group ####
      DUMB = "dumb"
      CONFIG.add_group(DUMB, RMP3)
    end

    class Display
      include Kconv

      def start(app)
	app.player.add_mpg123_info_callback do |player, mp3_info, mpg123_info|
	  STDOUT.print kconv(mpg123_info.line)
	  STDOUT.flush
	end
	app.start
      end
    end

    class Loader < SimpleLoader
      include Config

      def initialize(disp)
	super(DUMB)
	@disp = disp
      end

      def start(app)
	@disp.start(app)
      end
    end

    DISPLAY = Display::new
    LOADER = Loader::new(DISPLAY)
  end

  # registration
  add_loader(Dumb::LOADER)
end

# SIGINT (^C)
count = 0
trap("INT") do
  if (count > 0) then
    puts "Interrupted!"
    exit
  else
    count += 1
    begin
      sleep(1)
    ensure
      count -= 1
    end
  end
end
